=== debian/changelog ===
ompl (1.5.2+ds1-1) unstable; urgency=medium

  * New upstream version.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 02 Feb 2021 15:22:21 +0100

ompl (1.5.1+ds1-2) unstable; urgency=medium

  * Fix trailing newline in d/rules (lintian)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 25 Dec 2020 18:08:39 +0100

ompl (1.5.1+ds1-1) unstable; urgency=medium

  * New upstream version.
  * Delete unused patches.
  * Added package.xml to libompl-dev.
  * Update dates in copyright file.
  * Added patch to solve rename Python script. Closes: #976583
  * Enable verbose makefile
  * Set https in homepage
  * Bump Standards-Version. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 22 Dec 2020 16:59:26 +0100
