=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=4
#opts=dversionmangle=s/\.dfsg// \
opts=dversionmangle=s/\+ds1\d?$//,repacksuffix=+ds1 \
 https://github.com/ompl/ompl/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
