## ompl 1.6.0%2Bds1

=== demos/CMakeLists.txt ===
--- 
+++ 
@@ -30,27 +30,29 @@
     add_ompl_demo(demo_Koules ${Koules_SRC})
     add_ompl_demo(demo_PlannerData PlannerData.cpp)
     add_ompl_demo(demo_ThunderLightning ThunderLightning.cpp)
-
+    
     add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)
     add_ompl_demo(demo_PlannerProgressProperties PlannerProgressProperties.cpp)
     add_ompl_demo(demo_CForestCircleGridBenchmark CForestCircleGridBenchmark.cpp)
-
+    
     add_ompl_demo(demo_Diagonal Diagonal.cpp)
-
+    
     add_ompl_demo(demo_VectorFieldConservative VFRRT/VectorFieldConservative.cpp)
     add_ompl_demo(demo_VectorFieldNonconservative VFRRT/VectorFieldNonconservative.cpp)
-
+    
     add_ompl_demo(demo_ConstrainedPlanningSphere constraint/ConstrainedPlanningSphere.cpp)
     add_ompl_demo(demo_ConstrainedPlanningTorus constraint/ConstrainedPlanningTorus.cpp)
     add_ompl_demo(demo_ConstrainedPlanningImplicitChain constraint/ConstrainedPlanningImplicitChain.cpp)
     add_ompl_demo(demo_ConstrainedPlanningImplicitParallel constraint/ConstrainedPlanningImplicitParallel.cpp)
     add_ompl_demo(demo_ConstrainedPlanningKinematicChain constraint/ConstrainedPlanningKinematicChain.cpp)
+    
+    add_ompl_demo(demo_MultiLevelPlanningRigidBody2D multilevel/MultiLevelPlanningRigidBody2D.cpp)
+    add_ompl_demo(demo_MultiLevelPlanningRigidBody3D multilevel/MultiLevelPlanningRigidBody3D.cpp)
+    add_ompl_demo(demo_MultiLevelPlanningKinematicChain multilevel/MultiLevelPlanningKinematicChain.cpp)
+    add_ompl_demo(demo_MultiLevelPlanningHyperCube multilevel/MultiLevelPlanningHyperCube.cpp)
+    add_ompl_demo(demo_MultiLevelPlanningHyperCubeBenchmark multilevel/MultiLevelPlanningHyperCubeBenchmark.cpp)
 
-    add_ompl_demo(demo_QuotientSpacePlanningRigidBody2D quotientspace/QuotientSpacePlanningRigidBody2D.cpp)
-    add_ompl_demo(demo_QuotientSpacePlanningRigidBody3D quotientspace/QuotientSpacePlanningRigidBody3D.cpp)
-    add_ompl_demo(demo_QuotientSpacePlanningKinematicChain quotientspace/QuotientSpacePlanningKinematicChain.cpp)
-    add_ompl_demo(demo_QuotientSpacePlanningHyperCube quotientspace/QuotientSpacePlanningHyperCube.cpp)
-    add_ompl_demo(demo_QuotientSpacePlanningHyperCubeBenchmark quotientspace/QuotientSpacePlanningHyperCubeBenchmark.cpp)
+    add_ompl_demo(demo_SpaceTimePlanning SpaceTimePlanning.cpp)
 
     find_package(yaml-cpp)
     set_package_properties(yaml-cpp PROPERTIES
@@ -65,6 +67,15 @@
         target_include_directories(demo_PlanarManipulator PUBLIC ${YAMLCPP_INCLUDE_DIRS})
         target_link_libraries(demo_PlanarManipulator ${YAMLCPP_LIBRARIES})
     endif()
+    if (yaml-cpp_FOUND)
+        add_ompl_demo(demo_MultiLevelPlanarManipulator
+            multilevel/MultiLevelPlanarManipulatorDemo.cpp
+            PlanarManipulator/PlanarManipulator.cpp
+            PlanarManipulator/PolyWorld.cpp
+        )
+        target_include_directories(demo_MultiLevelPlanarManipulator PUBLIC ${YAMLCPP_INCLUDE_DIRS})
+        target_link_libraries(demo_MultiLevelPlanarManipulator ${YAMLCPP_LIBRARIES})
+    endif()
 
     if (OMPL_EXTENSION_ODE)
         add_ompl_demo(demo_OpenDERigidBodyPlanning OpenDERigidBodyPlanning.cpp)
@@ -72,7 +83,7 @@
 
     if (OMPL_EXTENSION_TRIANGLE)
         add_ompl_demo(demo_TriangulationDemo TriangulationDemo.cpp)
-        add_ompl_demo(demo_LTLWithTriangulation LTLWithTriangulation)
+        add_ompl_demo(demo_LTLWithTriangulation LTLWithTriangulation.cpp)
     endif()
 endif(OMPL_BUILD_DEMOS)
