=== py-bindings/CMakeLists.txt ===
--- 
+++ 
@@ -34,19 +34,19 @@
         else()
             create_module_generation_targets(base "[Cc]onstrain")
         endif()
+        add_dependencies(update_base_bindings update_util_bindings)
         create_module_generation_targets(geometric)
+        add_dependencies(update_geometric_bindings update_base_bindings)
         create_module_generation_targets(control)
-        create_module_generation_targets(tools)
+        add_dependencies(update_control_bindings update_geometric_bindings)
+        add_dependencies(update_control_bindings update_base_bindings)
+        if(APPLE)
+            create_module_generation_targets(tools)
+            add_dependencies(update_tools_bindings update_control_bindings)
+        endif()
+
         if(OMPL_EXTENSION_MORSE)
             create_module_generation_targets(morse)
-        endif()
-
-        add_dependencies(update_base_bindings update_util_bindings)
-        add_dependencies(update_geometric_bindings update_base_bindings)
-        add_dependencies(update_control_bindings update_geometric_bindings)
-        add_dependencies(update_control_bindings update_base_bindings)
-        add_dependencies(update_tools_bindings update_control_bindings)
-        if(OMPL_EXTENSION_MORSE)
             add_dependencies(update_morse_bindings update_base_bindings)
             add_dependencies(update_morse_bindings update_control_bindings)
         endif()
