=== debian/changelog ===
ompl (1.6.0+ds1-5build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:10:53 +0200

ompl (1.6.0+ds1-5build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:00:29 +0200

ompl (1.6.0+ds1-5) unstable; urgency=medium

  * Drop libopenmpi-dev in libompl-dev. Closes: #1104960

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Fri, 27 Jun 2025 09:59:09 +0200

ompl (1.6.0+ds1-4) unstable; urgency=medium

  * Version for unstable (Closes: #1103164)
  * Add lintian overrides of the ompl-plannerarena package.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sat, 26 Apr 2025 19:56:46 +0200

ompl (1.6.0+ds1-3~exp1) experimental; urgency=medium

  * Bump ABI version. Upstream defined it as 17, not 16.
  * Added autopkgtests.
  * Pushed to experimental.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sat, 12 Apr 2025 14:33:05 +0200

ompl (1.6.0+ds1-2) unstable; urgency=medium

  * Added patch to solve wrong Python detection on arm64 (Closes: #1091159)
  * Bump policy version (no changes)

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Fri, 04 Apr 2025 20:18:39 +0200

ompl (1.6.0+ds1-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 1.6.0+ds1
  * Add dependency on python3-setuptools (Closes: #1080686)

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Alexandre Detiste <tchet@debian.org>  Sat, 09 Nov 2024 23:15:01 +0100

ompl (1.5.2+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062823

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 02:24:02 +0000
