=== debian/tests/control ===
tests: autopkgtest
depends: @, libompl-dev, g++
